var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
define(["require", "exports", "lodash/invoke", "prop-types", "react", "./BaseInput", "../lib/CustomPropTypes", "../pickers/monthPicker/MonthRangePicker", "../views/InputView", "./parse"], function (require, exports, invoke_1, prop_types_1, react_1, BaseInput_1, CustomPropTypes_1, MonthRangePicker_1, InputView_1, parse_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    invoke_1 = __importDefault(invoke_1);
    prop_types_1 = __importDefault(prop_types_1);
    react_1 = __importDefault(react_1);
    BaseInput_1 = __importDefault(BaseInput_1);
    CustomPropTypes_1 = __importDefault(CustomPropTypes_1);
    MonthRangePicker_1 = __importDefault(MonthRangePicker_1);
    InputView_1 = __importDefault(InputView_1);
    var DATES_SEPARATOR = ' - ';
    var MonthRangeInput = /** @class */ (function (_super) {
        __extends(MonthRangeInput, _super);
        function MonthRangeInput(props) {
            var _this = _super.call(this, props) || this;
            _this.getPicker = function () {
                var _a = _this.props, value = _a.value, dateFormat = _a.dateFormat, initialDate = _a.initialDate, maxDate = _a.maxDate, minDate = _a.minDate, localization = _a.localization;
                var _b = parse_1.parseDatesRange(value, dateFormat), start = _b.start, end = _b.end;
                return (react_1.default.createElement(MonthRangePicker_1.default, { isPickerInFocus: _this.isPickerInFocus, isTriggerInFocus: _this.isTriggerInFocus, inline: _this.props.inline, onCalendarViewMount: _this.onCalendarViewMount, closePopup: _this.closePopup, onChange: _this.handleSelect, dateFormat: dateFormat, initializeWith: parse_1.buildValue(start, initialDate, localization, dateFormat), start: start, end: end, minDate: parse_1.parseValue(minDate, dateFormat, localization), maxDate: parse_1.parseValue(maxDate, dateFormat, localization), localization: localization, onHeaderClick: function () { return undefined; } }));
            };
            _this.handleSelect = function (e, _a) {
                var value = _a.value;
                var dateFormat = _this.props.dateFormat;
                var start = value.start, end = value.end;
                var outputString = '';
                if (start && end) {
                    outputString = "" + start.format(dateFormat) + DATES_SEPARATOR + end.format(dateFormat);
                }
                else if (start) {
                    outputString = "" + start.format(dateFormat) + DATES_SEPARATOR;
                }
                invoke_1.default(_this.props, 'onChange', e, __assign({}, _this.props, { value: outputString, date: value }));
                if (_this.props.closable && start && end) {
                    _this.closePopup();
                }
            };
            _this.state = {
                popupIsClosed: true,
            };
            return _this;
        }
        MonthRangeInput.prototype.render = function () {
            var _a = this.props, value = _a.value, dateFormat = _a.dateFormat, initialDate = _a.initialDate, maxDate = _a.maxDate, minDate = _a.minDate, closable = _a.closable, localization = _a.localization, rest = __rest(_a, ["value", "dateFormat", "initialDate", "maxDate", "minDate", "closable", "localization"]);
            return (react_1.default.createElement(InputView_1.default, __assign({ popupIsClosed: this.state.popupIsClosed }, rest, { value: value, onMount: this.onInputViewMount, closePopup: this.closePopup, openPopup: this.openPopup, renderPicker: this.getPicker })));
        };
        MonthRangeInput.defaultProps = __assign({}, BaseInput_1.default.defaultProps, { dateFormat: 'MM-YYYY', icon: 'calendar' });
        MonthRangeInput.propTypes = {
            /** Currently selected value. */
            value: prop_types_1.default.string,
            /** Moment date formatting string. */
            dateFormat: prop_types_1.default.string,
            /** Date to display initially when no date is selected. */
            initialDate: prop_types_1.default.oneOfType([
                prop_types_1.default.string,
                CustomPropTypes_1.default.momentObj,
                prop_types_1.default.instanceOf(Date),
            ]),
            /** Maximum date that can be selected. */
            maxDate: prop_types_1.default.oneOfType([
                prop_types_1.default.string,
                CustomPropTypes_1.default.momentObj,
                prop_types_1.default.instanceOf(Date),
            ]),
            /** Minimum date that can be selected. */
            minDate: prop_types_1.default.oneOfType([
                prop_types_1.default.string,
                CustomPropTypes_1.default.momentObj,
                prop_types_1.default.instanceOf(Date),
            ]),
            /** If true, popup closes after selecting a date-time. */
            closable: prop_types_1.default.bool,
            /**
             * Called on clear.
             *
             * @param {SyntheticEvent} event - React's original SyntheticEvent.
             * @param {object} data - All props and proposed value.
             */
            onClear: prop_types_1.default.func,
            /** Using the clearable setting will let users remove their selection from a calendar. */
            clearable: prop_types_1.default.bool,
            /** Optional Icon to display inside the clearable Input. */
            clearIcon: prop_types_1.default.any,
            /** Duration of the CSS transition animation in milliseconds. */
            duration: prop_types_1.default.number,
            /** Named animation event to used. Must be defined in CSS. */
            animation: prop_types_1.default.string,
            /** Moment date localization. */
            localization: prop_types_1.default.string,
            icon: prop_types_1.default.oneOfType([prop_types_1.default.string, prop_types_1.default.bool]),
            iconPosition: prop_types_1.default.oneOf(['left', 'right']),
        };
        return MonthRangeInput;
    }(BaseInput_1.default));
    exports.default = MonthRangeInput;
});
