var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
define(["require", "exports", "lodash/isNil", "react", "semantic-ui-react", "./HeaderRange", "./HeaderWeeks"], function (require, exports, isNil_1, react_1, semantic_ui_react_1, HeaderRange_1, HeaderWeeks_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    isNil_1 = __importDefault(isNil_1);
    react_1 = __importDefault(react_1);
    HeaderRange_1 = __importDefault(HeaderRange_1);
    HeaderWeeks_1 = __importDefault(HeaderWeeks_1);
    function Header(props) {
        var rangeRowContent = props.rangeRowContent, displayWeeks = props.displayWeeks, onNextPageBtnClick = props.onNextPageBtnClick, onPrevPageBtnClick = props.onPrevPageBtnClick, hasPrevPage = props.hasPrevPage, hasNextPage = props.hasNextPage, onHeaderClick = props.onHeaderClick, width = props.width, title = props.title, localization = props.localization;
        var cellStyle = {
            border: 'none',
            borderBottom: displayWeeks ? 'none' : '1px solid rgba(34,36,38,.1)',
        };
        var prevPageBtnStyle = {
            cursor: hasPrevPage ? 'pointer' : 'auto',
        };
        var nextPageBtnStyle = {
            cursor: hasNextPage ? 'pointer' : 'auto',
        };
        var headerTitleStyle = {
            cursor: onHeaderClick ? 'pointer' : 'default',
        };
        return (react_1.default.createElement(semantic_ui_react_1.Table.Header, null,
            !isNil_1.default(rangeRowContent) && react_1.default.createElement(HeaderRange_1.default, { content: rangeRowContent }),
            react_1.default.createElement(semantic_ui_react_1.Table.Row, null,
                react_1.default.createElement(semantic_ui_react_1.Table.HeaderCell, { style: cellStyle, colSpan: '1' },
                    react_1.default.createElement(semantic_ui_react_1.Icon, { fitted: true, style: prevPageBtnStyle, disabled: !hasPrevPage, onClick: hasPrevPage ? onPrevPageBtnClick : undefined, name: 'chevron left' })),
                react_1.default.createElement(semantic_ui_react_1.Table.HeaderCell, { onClick: onHeaderClick ? onHeaderClick : undefined, style: cellStyle, colSpan: (width - 2).toString() },
                    react_1.default.createElement("span", { style: headerTitleStyle }, title)),
                react_1.default.createElement(semantic_ui_react_1.Table.HeaderCell, { style: cellStyle, colSpan: '1' },
                    react_1.default.createElement(semantic_ui_react_1.Icon, { fitted: true, style: nextPageBtnStyle, disabled: !hasNextPage, onClick: hasNextPage ? onNextPageBtnClick : undefined, name: 'chevron right' }))),
            displayWeeks && react_1.default.createElement(HeaderWeeks_1.default, { localization: localization })));
    }
    exports.default = Header;
});
